using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using CyDesigner.Extensions.Common;
using CyDesigner.Extensions.Gde;

namespace dummy_app
{
    public partial class Form : UserControl, ICyParamEditingControl
    {        
        // formas
        private System.Windows.Forms.GroupBox   gb_hw_interface;
        private System.Windows.Forms.Label      lbl_spi_mtr;
        private System.Windows.Forms.Label      lbl_pin_ce;
        private System.Windows.Forms.Label      lbl_pin_ss;
        private System.Windows.Forms.Label      mensaje;
        private System.Windows.Forms.Button     button;
        
        // parametros
        private const string TEST_PARAM = "TEST";

        // objeto para construir el customizer
        ICyInstEdit_v1  m_component;
        
        public Form(ICyInstEdit_v1 obj)
        {
            this.m_component = obj;
            InitializeComponent();
        }
        
        Control ICyParamEditingControl.DisplayControl
        {
            get { return this; }
        }
        
        IEnumerable<CyCustErr> ICyParamEditingControl.GetErrors()
        {
            return new CyCustErr[] {};
        }
        
        private void InitializeComponent()
        {
            this.lbl_pin_ce = new System.Windows.Forms.Label();
            this.lbl_pin_ss = new System.Windows.Forms.Label();
            this.lbl_spi_mtr = new System.Windows.Forms.Label();
            this.mensaje = new System.Windows.Forms.Label();
            this.button = new System.Windows.Forms.Button();
            this.gb_hw_interface = new System.Windows.Forms.GroupBox();
            this.gb_hw_interface.SuspendLayout();
            
            this.SuspendLayout();
            // button2
            this.button.Location = new System.Drawing.Point(15, 80);
            this.button.Name = "button";
            this.button.Size = new System.Drawing.Size(75, 23);
            this.button.TabIndex = 1;
            this.button.Text = "button";
            this.button.UseVisualStyleBackColor = true;
            this.button.Click += new System.EventHandler(this.button_Click);
            // mensaje
            this.mensaje.AutoSize = true;
            this.mensaje.Location = new System.Drawing.Point(15, 115);
            this.mensaje.Name = "mensaje";
            this.mensaje.Size = new System.Drawing.Size(35, 13);
            this.mensaje.TabIndex = 0;
            this.mensaje.Text = "mensaje";
            // lbl_pin_ce
            this.lbl_pin_ce.AutoSize = true;
            this.lbl_pin_ce.Location = new System.Drawing.Point(15, 20);
            this.lbl_pin_ce.Name = "pin_ce";
            this.lbl_pin_ce.Size = new System.Drawing.Size(35, 13);
            this.lbl_pin_ce.TabIndex = 0;
            this.lbl_pin_ce.Text = "Pin CE";
            // lbl_pin_ce
            this.lbl_pin_ss.AutoSize = true;
            this.lbl_pin_ss.Location = new System.Drawing.Point(15, 40);
            this.lbl_pin_ss.Name = "pin_ss";
            this.lbl_pin_ss.Size = new System.Drawing.Size(35, 13);
            this.lbl_pin_ss.TabIndex = 1;
            this.lbl_pin_ss.Text = "Pin SS";
            // lbl_pin_ce
            this.lbl_spi_mtr.AutoSize = true;
            this.lbl_spi_mtr.Location = new System.Drawing.Point(15, 60);
            this.lbl_spi_mtr.Name = "spi_mtr";
            this.lbl_spi_mtr.Size = new System.Drawing.Size(35, 13);
            this.lbl_spi_mtr.TabIndex = 2;
            this.lbl_spi_mtr.Text = "SPI Master";
            // gb_hw_interface
            this.gb_hw_interface.Controls.Add(this.lbl_pin_ce);
            this.gb_hw_interface.Controls.Add(this.lbl_pin_ss);
            this.gb_hw_interface.Controls.Add(this.lbl_spi_mtr);
            this.gb_hw_interface.Controls.Add(this.mensaje);
            this.gb_hw_interface.Controls.Add(this.button);
            this.gb_hw_interface.Location = new System.Drawing.Point(5, 5);
            this.gb_hw_interface.Name = "Hardware interface";
            this.gb_hw_interface.Size = new System.Drawing.Size(200, 200);
            this.gb_hw_interface.TabIndex = 3;
            this.gb_hw_interface.TabStop = false;
            this.gb_hw_interface.Text = "Hardware interface";
            
            // Form
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(234, 211);
            this.Controls.Add(this.gb_hw_interface);
            this.Name = "Form";
            this.Text = "Form";
            this.ResumeLayout(false);

        }

        private void button_Click(object sender, EventArgs e)
        {
            Button clicked_button = (Button)sender;
            bool result;
            
            /*
            switch (clicked_button.Name) {
                case "button":
                    this.mensaje.Text = "Button 1";
                    break;
                case "button2":
                    this.mensaje.Text = "Button 2 :)";
                    break;
                default:
                    break;
            }
            */

            result = m_component.SetParamExpr(TEST_PARAM, "dos");
                
            if (false == result) {
                this.mensaje.Text = "Parameter not found";
            } else {
                this.mensaje.Text = "Parameter found";
            }
                
            result = m_component.CommitParamExprs();
                
            if (false == result) {
                this.mensaje.Text = "Parameter not validated";
            }
            
        }
        
    }
}

//[] END OF FILE
